# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from jsk_network_tools/FC2OCSLargeData.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sensor_msgs.msg
import std_msgs.msg

class FC2OCSLargeData(genpy.Message):
  _md5sum = "51c7ca6e66514e69ddd1a156f6a0b404"
  _type = "jsk_network_tools/FC2OCSLargeData"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# large message from FC to OSC
# topic name will be automatically generated from
# field names.
# the rule is super simple, just replace '__' with '/'
sensor_msgs/Image camera__rgb__image_rect_color
sensor_msgs/JointState joint_state
sensor_msgs/Image usb_cam__image_raw
================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of camera
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort
"""
  __slots__ = ['camera__rgb__image_rect_color','joint_state','usb_cam__image_raw']
  _slot_types = ['sensor_msgs/Image','sensor_msgs/JointState','sensor_msgs/Image']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       camera__rgb__image_rect_color,joint_state,usb_cam__image_raw

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FC2OCSLargeData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.camera__rgb__image_rect_color is None:
        self.camera__rgb__image_rect_color = sensor_msgs.msg.Image()
      if self.joint_state is None:
        self.joint_state = sensor_msgs.msg.JointState()
      if self.usb_cam__image_raw is None:
        self.usb_cam__image_raw = sensor_msgs.msg.Image()
    else:
      self.camera__rgb__image_rect_color = sensor_msgs.msg.Image()
      self.joint_state = sensor_msgs.msg.JointState()
      self.usb_cam__image_raw = sensor_msgs.msg.Image()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.camera__rgb__image_rect_color.header.seq, _x.camera__rgb__image_rect_color.header.stamp.secs, _x.camera__rgb__image_rect_color.header.stamp.nsecs))
      _x = self.camera__rgb__image_rect_color.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.camera__rgb__image_rect_color.height, _x.camera__rgb__image_rect_color.width))
      _x = self.camera__rgb__image_rect_color.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BI().pack(_x.camera__rgb__image_rect_color.is_bigendian, _x.camera__rgb__image_rect_color.step))
      _x = self.camera__rgb__image_rect_color.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.joint_state.header.seq, _x.joint_state.header.stamp.secs, _x.joint_state.header.stamp.nsecs))
      _x = self.joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state.position))
      length = len(self.joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state.velocity))
      length = len(self.joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state.effort))
      _x = self
      buff.write(_get_struct_3I().pack(_x.usb_cam__image_raw.header.seq, _x.usb_cam__image_raw.header.stamp.secs, _x.usb_cam__image_raw.header.stamp.nsecs))
      _x = self.usb_cam__image_raw.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.usb_cam__image_raw.height, _x.usb_cam__image_raw.width))
      _x = self.usb_cam__image_raw.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BI().pack(_x.usb_cam__image_raw.is_bigendian, _x.usb_cam__image_raw.step))
      _x = self.usb_cam__image_raw.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.camera__rgb__image_rect_color is None:
        self.camera__rgb__image_rect_color = sensor_msgs.msg.Image()
      if self.joint_state is None:
        self.joint_state = sensor_msgs.msg.JointState()
      if self.usb_cam__image_raw is None:
        self.usb_cam__image_raw = sensor_msgs.msg.Image()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.camera__rgb__image_rect_color.header.seq, _x.camera__rgb__image_rect_color.header.stamp.secs, _x.camera__rgb__image_rect_color.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.camera__rgb__image_rect_color.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.camera__rgb__image_rect_color.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.camera__rgb__image_rect_color.height, _x.camera__rgb__image_rect_color.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.camera__rgb__image_rect_color.encoding = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.camera__rgb__image_rect_color.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.camera__rgb__image_rect_color.is_bigendian, _x.camera__rgb__image_rect_color.step,) = _get_struct_BI().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.camera__rgb__image_rect_color.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.joint_state.header.seq, _x.joint_state.header.stamp.secs, _x.joint_state.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_state.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.position = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.velocity = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.effort = s.unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.usb_cam__image_raw.header.seq, _x.usb_cam__image_raw.header.stamp.secs, _x.usb_cam__image_raw.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.usb_cam__image_raw.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.usb_cam__image_raw.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.usb_cam__image_raw.height, _x.usb_cam__image_raw.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.usb_cam__image_raw.encoding = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.usb_cam__image_raw.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.usb_cam__image_raw.is_bigendian, _x.usb_cam__image_raw.step,) = _get_struct_BI().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.usb_cam__image_raw.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.camera__rgb__image_rect_color.header.seq, _x.camera__rgb__image_rect_color.header.stamp.secs, _x.camera__rgb__image_rect_color.header.stamp.nsecs))
      _x = self.camera__rgb__image_rect_color.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.camera__rgb__image_rect_color.height, _x.camera__rgb__image_rect_color.width))
      _x = self.camera__rgb__image_rect_color.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BI().pack(_x.camera__rgb__image_rect_color.is_bigendian, _x.camera__rgb__image_rect_color.step))
      _x = self.camera__rgb__image_rect_color.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.joint_state.header.seq, _x.joint_state.header.stamp.secs, _x.joint_state.header.stamp.nsecs))
      _x = self.joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state.position.tostring())
      length = len(self.joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state.velocity.tostring())
      length = len(self.joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state.effort.tostring())
      _x = self
      buff.write(_get_struct_3I().pack(_x.usb_cam__image_raw.header.seq, _x.usb_cam__image_raw.header.stamp.secs, _x.usb_cam__image_raw.header.stamp.nsecs))
      _x = self.usb_cam__image_raw.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.usb_cam__image_raw.height, _x.usb_cam__image_raw.width))
      _x = self.usb_cam__image_raw.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BI().pack(_x.usb_cam__image_raw.is_bigendian, _x.usb_cam__image_raw.step))
      _x = self.usb_cam__image_raw.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.camera__rgb__image_rect_color is None:
        self.camera__rgb__image_rect_color = sensor_msgs.msg.Image()
      if self.joint_state is None:
        self.joint_state = sensor_msgs.msg.JointState()
      if self.usb_cam__image_raw is None:
        self.usb_cam__image_raw = sensor_msgs.msg.Image()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.camera__rgb__image_rect_color.header.seq, _x.camera__rgb__image_rect_color.header.stamp.secs, _x.camera__rgb__image_rect_color.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.camera__rgb__image_rect_color.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.camera__rgb__image_rect_color.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.camera__rgb__image_rect_color.height, _x.camera__rgb__image_rect_color.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.camera__rgb__image_rect_color.encoding = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.camera__rgb__image_rect_color.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.camera__rgb__image_rect_color.is_bigendian, _x.camera__rgb__image_rect_color.step,) = _get_struct_BI().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.camera__rgb__image_rect_color.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.joint_state.header.seq, _x.joint_state.header.stamp.secs, _x.joint_state.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_state.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 12
      (_x.usb_cam__image_raw.header.seq, _x.usb_cam__image_raw.header.stamp.secs, _x.usb_cam__image_raw.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.usb_cam__image_raw.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.usb_cam__image_raw.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.usb_cam__image_raw.height, _x.usb_cam__image_raw.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.usb_cam__image_raw.encoding = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.usb_cam__image_raw.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.usb_cam__image_raw.is_bigendian, _x.usb_cam__image_raw.step,) = _get_struct_BI().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.usb_cam__image_raw.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_BI = None
def _get_struct_BI():
    global _struct_BI
    if _struct_BI is None:
        _struct_BI = struct.Struct("<BI")
    return _struct_BI
